<?php
	// Returns an array of forums - id, desc, name
	function getForums()
	{
		$count=0;
		$start="forums/";
		if($dir=opendir($start))
		{
			while (($file=readdir($dir))!=FALSE)
			{
				if ($file!="." && $file!="..")
				{
					$url=$start . $file;
					if (is_dir($url) && $file!=="_vti_cnf")
					{
						$dirlist[$count]->id=$file;
						$dirlist[$count]->desc=getFile($url . "/desc.txt");
						$dirlist[$count++]->name=getFile($url . "/name.txt");
					}
				}
			}
			closedir($dir);
			if ($dirlist!==NULL) sort($dirlist);	// Sort by ID
		}
		return $dirlist;
	}

	// Return all the topics in this forum - id, description, 'name'
	function getTopics($f)
	{
		global $skin;
		$count=0;
		$start="forums/" . $f . "/";
		if($dir=opendir($start))
		{
			while (($file=readdir($dir))!=FALSE)
			{
				if ($file!="." && $file!="..")
				{
					$url=$start . $file;
					if (is_dir($url) && $file!=="_vti_cnf")
					{
						// Get last post date from latpost.txt or dir mod time
						$flnm=$url."/lastpost.txt";
						if (file_exists($flnm))
						{
							$dirlist[$count]->time=filemtime($flnm);
						}
						else
						{
							$dirlist[$count]->time=filemtime($url);
						}
						$dirlist[$count]->id=$file;
						$dirlist[$count]->desc=getFile($url . "/desc.txt");
						$dirlist[$count]->name=getFile($url . "/name.txt");
						// If this starts with ! it is a headline, so ad gfx and move to top of list
						if (substr($dirlist[$count]->name,0,1)=='!')
						{
							if (file_exists("image/skin/".$skin."/headline.gif"))
							{
								$dirlist[$count]->name="<img src='image/skin/".$skin."/headline.gif' alt='".$GLOBALS['l_getHead']."'> " . substr($dirlist[$count]->name,1);
							}
							else
							{
								$dirlist[$count]->name="[!] " . substr($dirlist[$count]->name,1);
							}
							$dirlist[$count]->time=time();
						}
					}
					$count++;
				}
			}
			closedir($dir);
			if ($dirlist!==NULL) rsort($dirlist);	// Sort by datestamp to move new posts to the top
		}
		return $dirlist;
	}

	// Count how many topics are in this forum
	function countTopics($f)
	{
		$count=0;
		$start="forums/" . $f . "/";
		if($dir=opendir($start))
		{
			while (($file=readdir($dir))!=FALSE)
			{
				if ($file!="." && $file!="..")
				{
					$url=$start . $file;
					if (is_dir($url) && $file!=="_vti_cnf") $count++;
				}
			}
			closedir($dir);
		}
		return $count;
	}

	// Return all posts for this page as an array - id, time, poster, desc
	function getPosts($f, $t)
	{
		$count=0;
		$start="forums/" . $f . "/" . $t . "/";
		if (file_exists($start))
		{
			if($dir=opendir($start))
			{
				while (($file=readdir($dir))!=FALSE)
				{
					if ($file!="." && $file!="..")
					{
						$url=$start . $file;
						if (strpos($file, ".dat")>-1)
						{
							$dirlist[$count]->id=str_replace(".dat","",$file);  // ID number used for link as #num
							$dirlist[$count]->time=filemtime($url);
							$dirlist[$count]->poster=getFile(str_replace(".dat",".usr",$url));
							$dirlist[$count++]->desc=getFile($url);
						}
					}
				}
				closedir($dir);
				if ($dirlist!==NULL) sort($dirlist);	// Sort by ID
			}
		}
		return $dirlist;
	}

	// Count how many posts in this topic
	function countPosts($f, $t)
	{
		$count=0;
		$start="forums/" . $f . "/" . $t . "/";
		if($dir=opendir($start))
		{
			while (($file=readdir($dir))!=FALSE)
			{
				if ($file!="." && $file!="..")
				{
					if (strpos($file, ".dat")>-1) $count++;
				}
			}
			closedir($dir);
		}
		return $count;
	}

	// This reads in a file devoid of nasty tags
	function getFile($f)
	{
		$files=" ";
		if (file_exists($f))
		{
			$handle = fopen($f, "r");
			//$files = file_get_contents($f);
			$files = implode("",file($f));
			fclose($handle);
			$files=str_replace("<html>","",$files);
			$files=str_replace("</html>","",$files);
			$files=str_replace("<head>","",$files);
			$files=str_replace("</head>","",$files);
			$files=str_replace("<body>","",$files);
			$files=str_replace("</body>","",$files);
		}
		return $files;
	}


	// Returns an array of users on-line
	function getUsersOnLine()
	{
		$count=0;
		$start="users/";
		$curTime=time();
		$dirlist=NULL;
		if($dir=opendir($start))
		{
			while (($file=readdir($dir))!=FALSE)
			{
				if ($file!="." && $file!="..")
				{
					$url=$start . $file;
					if (strpos($file, ".time")>-1)
					{
						$dirlist[$count]->user=str_replace(".time","",$file);
						$dirlist[$count]->tm=getFile($url);
						if ($curTime>$dirlist[$count]->tm+60)
						{
							unlink($url);
						}
						$count++;
					}
				}
			}
			closedir($dir);
			if ($dirlist!==NULL) sort($dirlist);	// Sort by ID
		}
		return $dirlist;
	}

	// Show user info (for posts, view profile etc) shows details and avatar
	function showUser($u)
	{
		echo "<a class='link' href='profile.php?action=view&amp;uname=" . $u . "'>" . $u . "</a>\n";
		$t="users/" . $u . ".info";
		if (file_exists($t)) 
		{
			if (strpos(getFile($t), "admin")>-1) echo "<br>\n<span class='little'>(Admin)\n</span>\n";
		}
		$t=getFile("users/" . $u . ".pic");
		if (file_exists($t)) echo "<br><img src='" . $t . "' alt='Avatar'>\n";
		$t="users/" . $u . ".skin";
		if (file_exists($t)) echo "<br>\n<span class='little'>".$GLOBALS['l_profSkin'].": " . getFile($t) . "\n</span>\n";
		$t="users/" . $u . ".lang";
		if (file_exists($t)) echo "<br>\n<span class='little'>".$GLOBALS['l_profLang'].": " . getFile($t) . "\n</span>\n";
		$t="users/" . $u . ".hits";
		if (file_exists($t)) echo "<br>\n<span class='little'>".$GLOBALS['l_getPosts'].": " . getFile($t) . "\n</span>\n";
		$t="users/" . $u . ".stat";
		if (file_exists($t)) echo "<br>\n<div class='altquote'>\n" . getFile($t) . "\n</div>\n<br>\n";
	}

	// Show user lite (for last post)
	function showLUser($u)
	{
		echo "<a class='link' href='profile.php?action=view&amp;uname=" . $u . "'>" . $u . "&nbsp;</a>";
	}

	// Used when editing a post - transforms html into forum-coded text
	function decode($txt)
	{
		// Emoticons
		$txt=str_replace("<img src='emoticons/smile.gif'>",":)",$txt);		// Smile
		$txt=str_replace("<img src='emoticons/wink.gif'>",";)",$txt);		// Wink
		$txt=str_replace("<img src='emoticons/laugh.gif'>",":D",$txt);		// Laugh
		$txt=str_replace("<img src='emoticons/indifferent.gif'>",":I",$txt);	// Indifferent
		$txt=str_replace("<img src='emoticons/sad.gif'>",":(",$txt);		// Sad
		$txt=str_replace("<img src='emoticons/wry.gif'>",":\\",$txt);		// Wry

		// Formatting
		$txt=str_replace("<pre>","[pre]",$txt);			// Pre start
		$txt=str_replace("</pre>","[/pre]",$txt);		// Pre end
		$txt=str_replace("<b>","[b]",$txt);			// Bold start
		$txt=str_replace("</b>","[/b]",$txt);			// Bold end
		$txt=str_replace("<div class='quote'>","[q]",$txt);	// Quote start
		$txt=str_replace("<div id='quote'>","[q]",$txt);	// Quote start
		$txt=str_replace("</div>","[/q]",$txt);			// Quote end
		$txt=str_replace("<em>","[i]",$txt);			// Italic Start
		$txt=str_replace("</em>","[/i]",$txt);			// Italic End
		$txt=str_replace("<a href='","[a]",$txt);		// Link
		$txt=str_replace("' class='link'>link</a>","[/a]",$txt); // Link
		$txt=str_replace("'>link</a>","[/a]",$txt); 		// Link End
		$txt=str_replace("'link","",$txt); 		// Fix bad links in old posts
		$txt=str_replace("<img src='","[img]",$txt);		// Image
		$txt=str_replace("' name='pic'>","[/img]",$txt);	// Image End

		// Generic slash, newline, tag stripping
		$txt=stripslashes($txt);
		$txt=strip_tags($txt);
		$txt=str_replace(array("<",">"),"",$txt);

		return $txt;
	}

	// For menu bar on right hand side, forum list
	function showMiniForums()
	{
		echo "<a class='link' href='index.php'>".$GLOBALS['l_index']."</a><br>\n";
		$ourDir = getForums();
		for ($i=0; $i<count($ourDir); $i++)
		{
			echo "<a class='link' href='index.php?f=" .  $ourDir[$i]->id . "'>" . $ourDir[$i]->name . "</a><br>\n";
		}
	}

	// Get highest ID from an array
	function getHighest($a)
	{
		$h=0;
		for ($i=0; $i<count($a); $i++)
		{
			if ($a[$i]->id>$h) $h=$a[$i]->id;
		}
		return $h;
	}

	// Increments counter for topic view hits
	// Based on freeware script by http://www.cj-design.com/?id=forum
	function hitme($fname)
	{
		if (file_exists($fname))
		{
			$handle = fopen($fname, "r+");
			flock($handle, 1);
			$count = fgets($handle, 4096);
			if ($count==NULL) $count=0;
			$count++; 
			fseek($handle, 0);
			flock($handle, 3);
 			fwrite($handle, $count);
			fclose($handle);
		}
		else 
		{
			$handle = fopen($fname, 'w');
			fwrite($handle, "1");
			fclose($handle);	
		}
	}
?>
